﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Windows.Threading;
using Xceed.Wpf.DataGrid;
using System.Diagnostics;
using Infragistics.Windows.DockManager;
using System.IO;

namespace BarclaysCapital.CR.PDC.Margin
{
    /// <summary>
    /// Interaction logic for CallAndAlertManager.xaml
    /// </summary>
    public partial class CallAndAlertManager : ScreenControl
    {
        private readonly CallAndAlertManagerData _data = new CallAndAlertManagerData();

        public CallAndAlertManager()
        {
            InitializeComponent();
        }

        public static string Header
        {
            get
            {
                return "Call & Alert Manager";
            }
        }

        public void SetData()
        {
            Dispatcher.BeginInvoke(DispatcherPriority.Background, (Action)UpdateAutoFilterValues);
        }

        private void UpdateAutoFilterValues()
        {
            var dgcvCalls = (DataGridCollectionView)dgcCalls.ItemsSource;
            Debug.Assert(dgcvCalls != null);
        }

        public IBindingList CallList
        {
            get
            {
                if (_data != null)
                {
                    return _data.CallList;
                }

                return new BindingList<CallAndAlertManagerData.Call>();
            }
        }

        private void dockManager_ToolWindowLoaded(object sender, Infragistics.Windows.DockManager.Events.PaneToolWindowEventArgs e)
        {
            e.Window.DataContext = CallList;
        }

        public override void SaveLayout()
        {
            // Ensure the application data path to save layout data exists
            if (!Directory.Exists(App.ApplicationDataPath))
            {
                Directory.CreateDirectory(App.ApplicationDataPath);
            }

            string layoutFileName = System.IO.Path.Combine(App.ApplicationDataPath, dockManager.Name + " Layout.xml");
            using (var stream = new FileStream(layoutFileName, FileMode.Create))
            {
                dockManager.SaveLayout(stream);
            }
        }

        public override void LoadLayout()
        {
            string layoutFileName = System.IO.Path.Combine(App.ApplicationDataPath, dockManager.Name + " Layout.xml");
            if (File.Exists(layoutFileName) && new FileInfo(layoutFileName).Length > 0)
            {
                using (var stream = new FileStream(layoutFileName, FileMode.Open))
                {
                    dockManager.LoadLayout(stream);
                }
            }
        }
    }
}
